﻿init python:
    import pygame
    import math
    import random
    import time
    random.seed(time.perf_counter_ns())
    renpy.music.register_channel("sfx1", "sfx", False)
    def distance(x, y):
        if x >= y:
            result = x - y
        else:
            result = y - x
        return result
    def spawn_something(x, y):
        tag = f"shum_ex_{random.randint(0,10000)}"
        Show("spawn_something", x = x, y = y, z = 8, tag = tag, _tag = tag)()
    class campfire_ghost(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.speed = .4
            self.visible = True
            self.sway = 0
            self.sway_direction = 1
            self.parent = parent

        def got_damaged(self):
            # renpy.play("campfire/damaged.ogg", "sfx1")
            self.visible = False
            spawn_something(self.x, self.y)

        def render(self,width,height,st,at):
            if self.visible:
                if distance(self.y, 0) < 4:
                    if distance(self.x, 0) < 4:
                        self.visible = False
                        return renpy.Render(0,0)
                dx = 0 - self.x
                dy = 0 - self.y
                angle = math.atan2(dy, dx)
                xVelocity = self.speed * math.cos(angle)
                yVelocity = self.speed * math.sin(angle)
                self.x += xVelocity
                self.y += yVelocity
                self.sway += self.sway_direction/4
                if abs(self.sway) > 10:
                    self.sway_direction = -self.sway_direction
                if self.x < 0:
                    xzoom = 1
                else:
                    xzoom = -1

                if distance(self.x, self.parent.current[1][0]) < 16:
                    if distance(self.y+self.sway, self.parent.current[1][1]) < 8:
                        self.parent.stat = "dead"
                        self.parent.kill_count += 1

                t = Transform(self.image, xanchor=0.5, yanchor=0.5, xzoom = xzoom, alpha = .1+abs(self.sway)*.02)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x,self.y+self.sway))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
  
    class campfire_level:
        def __init__(self, name):
            self.name = name
            self.enemy_list = [
                "campfire_ghost_1",
                "campfire_ghost_2",
                "campfire_ghost_3",
                "campfire_ghost_4",
                "campfire_ghost_5",
                "campfire_ghost_6",
                "campfire_ghost_7",
            ]
            self.enemies = []
            self.kill_count = 0
            self.positions = [
                ["campfire_player_up", (0,-36)],
                ["campfire_player_down", (0,28)],
                ["campfire_player_left", (-60,-8)],
                ["campfire_player_right", (60,-8)],
            ]
            self.current = self.positions[0]
            self.stat = "start"

        def restart(self):
            self.kill_count = 0
            self.enemies = []
            self.stat = "playing"
        def change(self, i):
            self.current = self.positions[i]
        def spawn(self):
            for i in self.enemies:
                if not i.visible:
                    self.enemies.remove(i)
            if len(self.enemies) < 10:
                p = [random.randint(-320, 320), random.choice([-320, 320])]
                random.shuffle(p)
                ghost = campfire_ghost(random.choice(self.enemy_list), *p, self)
                self.enemies.append(ghost)


screen spawn_something(x,y,z,tag):
    fixed:
        xysize 320,180 align .5,.5
        at zoom(3, True)
        add "shoomup_explosion" align .5,.5 offset x,y
    timer 1 repeat True action Hide(tag)
screen ghost_camp_screen():
    modal True
    default g = campfire_level("1")
    fixed:
        add "campfire_1" align .5,.5
        add "campfire_log_up" align .5,.5 offset 0,-32
        add "campfire_log_down" align .5,.5 offset 0,32
        add "campfire_log_left" align .5,.5 offset -64,0
        add "campfire_log_right" align .5,.5 offset 64,0
        add g.current[0] offset g.current[1] align .5,.5
        xysize 640,360 align .5,.5
        at zoom(3, True)
        for i in g.enemies:
            add i align .5,.5

    if g.stat == "playing":
        key "w" action Function(g.change, 0)
        key "s" action Function(g.change, 1)
        key "a" action Function(g.change, 2)
        key "d" action Function(g.change, 3)
        timer 1 repeat True action Function(g.spawn)
    elif g.stat == "start":
        hbox:
            spacing 10 align .5,.5
            button:
                padding 20,20 background "#174f4d"
                text "start"
                action Function(g.restart)
    elif g.stat == "dead":
        hbox:
            spacing 10 align .5,.5
            button:
                padding 20,20 background "#174f4d"
                text "Re-try"
                action Function(g.restart)
    vbox:
        text str(g.kill_count)

init:
    image campfire_ghost_1 = Crop((0,0,32,32), "campfire/ghost camp.png")
    image campfire_ghost_2 = Crop((32,0,32,32), "campfire/ghost camp.png")
    image campfire_ghost_3 = Crop((64,0,32,32), "campfire/ghost camp.png")
    image campfire_ghost_4 = Crop((96,0,32,32), "campfire/ghost camp.png")
    image campfire_ghost_5 = Crop((0,32,32,32), "campfire/ghost camp.png")
    image campfire_ghost_6 = Crop((32,32,32,32), "campfire/ghost camp.png")
    image campfire_ghost_7 = Crop((64,32,32,32), "campfire/ghost camp.png")
    image campfire_1 = Crop((0,0,32,32), "campfire/campfire.png")

    image campfire_log_up = Crop((0,64,32,16), "campfire/ghost camp.png")
    image campfire_log_down = Crop((0,80,32,16), "campfire/ghost camp.png")
    image campfire_log_right = Crop((32,64,16,16), "campfire/ghost camp.png")
    image campfire_log_left = Crop((32,80,16,16), "campfire/ghost camp.png")

    image campfire_player_left = Crop((48,64,16,32), "campfire/ghost camp.png")
    image campfire_player_right = Crop((64,64,16,32), "campfire/ghost camp.png")
    image campfire_player_up = Crop((80,64,16,32), "campfire/ghost camp.png")
    image campfire_player_down = Crop((96,64,16,32), "campfire/ghost camp.png")

label ghost_camp_example:
    call screen ghost_camp_screen





